routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route Categories
Route::resource('Categories', 'Categories\CategoriesController')->middleware('auth');
Route::resource('user', 'Users\UserController')->middleware('auth');
Route::resource('products', 'Products\ProductController')->middleware('auth');

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Users/UserController.php
<?php

namespace App\Http\Controllers\Users;
use App\User;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;


class UserController extends Controller
{


    // middleware para que solo deje pasar a las vistas los usuarios autenticados
    // public function __construct()
    // {
    //     $this->middleware('auth');
    // }


    public function index()
    {

        $users=User::orderBy('id', 'DESC')->paginate(10);
        return view('auth.register', compact('users'));
    }


    public function show($id)
    {
        $users=User::find($id);
        return view(' user.show',compact('users'));
    }



    public function edit($id)
    {
        $users=User::find($id);
        return view('user.edit', compact('users'));
    }



    public function update(Request $request, $id)
    {

    $data=$request->all();
    $hash=bcrypt($request->password);
    $data['password']=$hash;
        $this->validate($request, [
            'name' => ['required','string','max:255'],
            'email' => ['required', 'string', 'email', 'max:255',
            Rule::unique('users', 'email')->ignore($id),
        ],
            'password' => ['required','string','min:8','confirmed'],
        ]);
        User::find($id)->update($data);
        alert()->success('Success Message', 'Usuario modificado con éxito')->autoclose(3500);
        return redirect()->route('user.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        User::find($id)->delete();
        alert()->success('Success Message', 'Usuario Eliminado Correctamente')->autoclose(3500);
        return redirect()->route('user.index');
    }
}

resources/views/user/edit.blade.php
@extends('layouts.app')
@section('content')

<div class="container">
  <div class="row justify-content-center">
    <div class="col-md-6">
      <div class="card o-hidden border-0 shadow-lg my-5">
        <div class="card-header">Actualizar Usuario</div>
        <div class="card-body">
          <form method="POST" action="{{ route('user.update',$users->id) }}">
             {{ csrf_field() }}
          <input name="_method" type="hidden" value="PATCH"> <!-- define que la ruta establecida en el from va con PUT o PATCH-->
              <div class="form-group row">
                  <label for="name" class="col-md-4 col-form-label text-md-right">Nombre<span class="required" style="color:red">*</span></label>
                  <div class="col-md-6">
                      <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{$users->name}}" required autocomplete="name" autofocus>
                      @error('name')
                          <span class="invalid-feedback" role="alert">
                              <strong>{{ $message }}</strong>
                          </span>
                      @enderror
                  </div>
              </div>

              <div class="form-group row">
                  <label for="email" class="col-md-4 col-form-label text-md-right">Correo Electrónico<span class="required" style="color:red">*</span></label>
                  <div class="col-md-6">
                      <input id="email" type="email" class="form-control @error('email') is-invalid @enderror" name="email" value="{{$users->email}}" required autocomplete="email">
                      @error('email')
                          <span class="invalid-feedback" role="alert">
                              <strong>{{ $message }}</strong>
                          </span>
                      @enderror
                  </div>
              </div>

              <div class="form-group row">
                  <label for="password" class="col-md-4 col-form-label text-md-right">Contraseña<span class="required" style="color:red">*</span></label>
                  <div class="col-md-6">
                      <input id="password" type="password" class="form-control @error('password') is-invalid @enderror" name="password" required autocomplete="new-password">

                      @error('password')
                          <span class="invalid-feedback" role="alert">
                              <strong>{{ $message }}</strong>
                          </span>
                      @enderror
                  </div>
              </div>

              <div class="form-group row">
                  <label for="password-confirm" class="col-md-4 col-form-label text-md-right">Confirmar Contraseña<span class="required" style="color:red">*</span></label>

                  <div class="col-md-6">
                      <input id="password-confirm" type="password" class="form-control" name="password_confirmation" required autocomplete="new-password">
                  </div>
              </div>

            <div class="form-group row mb-0">
              <div class="col-md-6 offset-md-4">
                <input type="submit"  value="Actualizar" class="btn btn-primary">
                <a href="{{ route('user.index') }}" class="btn btn-danger" >Cancelar</a>
              </div> 
            </div>

          </form>
        </div>
      </div>
    </div>
  </div>
</div>
 @endsection